//==================================================================//
//		BSSnake.cpp													//									
//		Created by O. Reshta (http://www.brigsoft.com), July 2001.	// 
//																	//
//		You can use and modify this file free on terms:				//	
//		1) Don't remove this title.									//
//		2) You will take all responsibility							//
//		   for project functionality after changing this file.		//
//																	//
//		Recommendation: You would insert "Modified  by " comment	//
//						if you will modify this file.				//
//==================================================================//

//Modified by:

// This file was generated by Visual studio. I made some changes. See OR comments.
// OR: Thread and window initialization. WinMain function. Messages loop.
#include "stdafx.h"
#include "resource.h"
#include "Engine.h"

CEngine gEngine;								// OR: Global object encapsulate main window functions.

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE ghInst;								// Current instance handler.
HWND ghWnd;										// Main wnd handler.

TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// The title bar text

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_BSSNAKE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_BSSNAKE);

	// OR: Main message loop:
	// OR: I use PeekMessage instead GetMessage to organize On-Idle circle. 
//	while (GetMessage(&msg, NULL, 0, 0)) 
	while (1) 
	{
		if(!PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			// OR: there are no any message. OnIdle;-)
			gEngine.TimerProc();
			continue;
		}

		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		if(msg.message == WM_QUIT){
			break;
		};
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_BSSNAKE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_BSSNAKE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   // OR. Global instance variable initialization.
   ghInst = hInstance; // Store instance handle in our global variable

   // OR. To fix window size I don't use WS_THICKFRAME style flag.
   DWORD dwStyle = WS_OVERLAPPED| WS_CAPTION| WS_SYSMENU| WS_MINIMIZEBOX|WS_MAXIMIZEBOX| WS_BORDER; 

	int nH = gnRows*gnCellSize;
	int nW = gnCols*gnCellSize;

   // OR. Window creates. Global window handle initialization.
   ghWnd = CreateWindow(szWindowClass, szTitle, dwStyle,
      100, 50, nW+10, nH+47, NULL, NULL, hInstance, NULL);

   if (!ghWnd)
   {
      return FALSE;
   }

   ShowWindow(ghWnd, nCmdShow);
   UpdateWindow(ghWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	//OR: All window messages I execute in the engine object.
	return gEngine.WinProc(hWnd, message, wParam, lParam);
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
