//==================================================================//
//		Engine.h													//									
//		Created by O. Reshta (http://www.brigsoft.com), July 2001.	// 
//																	//
//		You can use and modify this file free on terms:				//	
//		1) Don't remove this title.									//
//		2) You will take all responsibility							//
//		   for project functionality after changing this file.		//
//																	//
//		Recommendation: You would insert "Modified  by " comment	//
//						if you will modify this file.				//
//==================================================================//

//Modified by:


#ifndef ENGINE_H
#define ENGINE_H

#include "Game.h"


// - CEngine ------------------------------------------
// Base engine. It encapsulates all windows messages, 
// emulates timer, and generates game steps.

class CEngine
{
public:
	
	CEngine();
	
	TimerProc();			// Game ticks generator;
	void Init();			// Init game.

	// Same as SDK WinProc. Called by SDK WinProc.
	LRESULT WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

private:
	
	void OnDraw(HDC hDC);	// Main window drawing.

	void ExecuteTimeTick(); // Game steps generator.

	// Main window messages functions.
	LRESULT OnCreateWindow(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnKeyUp(WPARAM wParam, LPARAM lParam);

	
private:

	CPlayBox m_PlayBox;		// Game field. It consists of cells.  

	int m_nOldTime;			// Game ticker variable.	
	int m_nDeltaTime;		// Game steps period (milliseconds).
	int m_nTicker;			// Number of ticks from start of the game.


	int m_nOldAutoTime;		// Variables help prevent keyboard auto repeat. 
	int m_nAutoRepDelta;	
	BOOL m_bLockKey; 

	char m_szBuff[256];		// String buffer uses for score output.
	
};

#endif 